//+-------------------------------------------------------------------------------------------+
//|                                        PivotsMW.mq4                                       |
//+-------------------------------------------------------------------------------------------+

#property copyright "Traderathome - public domain code"
#property link      "n/a" 

/*--------------------------------------------------------------------------------------------+
PivotsMW:

Both Monthy and Weekly pivots can be displayed with this indicator. 

It provides for color and line style selection of pivot lines.  It provides for color, font 
size and font style selection of line labels, and the ability to position labels from far left 
(default setting) to far right.  Zooming in/out on the chart is an activity that can distort 
the position of labels, but with each data tic label positioning is automatically restored.  
Included is the ability to independently turn on/off the price displayed in the line labels and 
also in the right chart margin. Pivot lines can be calculated using either the "Daily" pivot 
formula (default), or the "Fibonacci" formula, which has two added levels.  Included are 
MidPivot lines which can be turned on/off.

The first item in the Indicator Window is the indicator "On/Off" switch (default=true).  By  
turning the indicator display "Off", you do not have to remove the indicator from your chart 
list when not in use, and meanwhile the indicator settings for that chart are preserved.


PivotsMW_v2:

My apologies to users for errant pivots in the initial release, and my gratitude to grant18265 
for bringing this to my attention.  They are corrected in this revision.  "THANKS!" are owed 
to Domas4 for coding the line displays so they can be of one configuration prior to the Today 
session and of a different configuration for the Today session! Furthermore, Domas4 has 
re-coded the price labels so that they are now compatible with non-forex items!  Set the input 
to "false" on charts for non-forex items such as Gold, Stocks, etc.


PivotsMW_v3:

The external input for labels font style was changed to allow the actual neme of a font style 
to be typed in.  Thus, more style choices are now available to the user.  Arial, Arial Bold 
and Verdana Bold are recommended, with font sizes 8 to 12.


PivotsMW_v4:

New code allows the MW pivot lines to be started at the current candle.  New code also lets
the lines be stopped at the current candle.  This is to allow them to be matched with the 
D pivot lines using the same new options.  The external inputs section has been re-worked for 
improved clarity and consistency of terminology.
                                                                              - Traderathome                 
---------------------------------------------------------------------------------------------*/
#property  indicator_chart_window
#property indicator_buffers  1
#property indicator_color1   CLR_NONE
/*---------------------------------------------------------------------------------------------
Color Suggestions:

Item                            White Chart              Black Chart   

MainPivot_Color                 Blue                     C'27,63,171'
Pivot_Resistances_Color         Red                      Maroon     
Pivot_Supports_Color            LimeGreen                DarkGreen   
MidPivots_Color                 Olive                    C'85,85,0'
LabelsColor                     MidnightBlue             DarkGray 
---------------------------------------------------------------------------------------------*/
extern bool   Indicator_On                   = true;
extern bool   Use_For_Forex                  = true;
extern string _                              = "";       
extern string Part_1                         = "Pivots & Formulas Settings:";
extern bool   Show_Monthly_Pivots            = true;
extern bool   Monthly_Use_Day_Formula        = true;
extern bool   Show_Weekly_Pivots             = true;
extern bool   Weekly_Use_Day_Formula         = true;
extern string __                             = "";
extern string Part_2                         = "Pivot Line Color & Selection Settings:";
extern color  Central_Pivot_Color            = Blue;
extern color  Resistance_Pivots_Color        = Red;
extern color  Support_Pivots_Color           = LimeGreen;
extern bool   Show_Monthly_MidPivots         = true; 
extern bool   Show_Weekly_MidPivots          = true;
extern color  MidPivots_Color                = Olive;
extern string ___                            = "";
extern string Part_3                         = "Pivot Lines Dual Style Settings:";
extern string note1                          = "Pivot lines thru *CurrentDay* can have";
extern string note2                          = "different style than used for lines thru";
extern string note3                          = "prior days & full screen, *PriorDaysFS*";
extern int    CurrentDay_LineStyle_01234     = 2;
extern int    CurrentDay_SolidLineThickness  = 1; 
extern int    PriorDaysFS_LineStyle_01234    = 0;     
extern int    PriorDaysFS_SolidLineThickness = 1;
extern string ____                           = "";
extern string Part_4                         = "Pivot Line Configuration Settings:";
extern string note4                          = "Single style lines = 1.";
extern string note5                          = "Dual style lines = 2.";
extern int    Line_Configuration_Number      = 2;
extern bool   StartLines_At_Current_Candle   = false;
extern bool   Endlines_At_Current_Candle     = false;
extern string _____                          = "";
extern string Part_5                         = "Pivot Labels Settings:";  
extern color  PivotLabels_Color              = MidnightBlue;//DarkGray
extern string PivotLabels_FontStyle          = "Arial Bold";
extern int    PivotLabels_Fontsize           = 9;
extern int    Shift_PivotLabels_PerCent_Left = 100; 
extern bool   Show_Price_in_PivotLabels      = true;
extern bool   Show_RightMargin_Prices        = true;
extern bool   Subordinate_Labels             = true;

int    fxDigits,CalcPeriod,shift,dow;
double HiPrice,LoPrice,Range,ClosePrice,Pivot,R1,S1,R2,S2,R3,S3,R4,S4,R5,S5;
string Price;

//+-------------------------------------------------------------------------------------------+
//| Indicator Initialization                                                                  |
//+---------------------------------------------------------------------------------------=---+
int init()
   {
   if(Use_For_Forex)  {string sub=StringSubstr(Symbol(), 3, 3);
      if (sub == "JPY") {fxDigits = 2;} else {fxDigits = 4;}}
   return(0);
   }
     
//+----------------------------------------------------------------------------------------=--+
//| Indicator De-initialization                                                               |
//+-------------------------------------------------------------------------------------------+  
int deinit()
   {    
   int obj_total= ObjectsTotal();  
   for (int k= obj_total; k>=0; k--) 
      {
      string name= ObjectName(k);           
      if (StringSubstr(name,0,10)=="[PivotsMW]") {ObjectDelete(name);}
      }   
   return(0);
   }
   
//+-------------------------------------------------------------------------------------------+
//| Indicator Start                                                                           |
//+-------------------------------------------------------------------------------------------+   
int start()
   {
   deinit(); if (Indicator_On == false){return(0);}
 
   //Establish time at day separator
   int startofday= iTime(NULL, PERIOD_D1, 0); 
   int startofday2= Time[1];    
   if (Time[0] > iTime(NULL, PERIOD_D1, 0)){startofday2 = iTime(NULL, PERIOD_D1, 0);}  
            
   //Do Weekly Pivots--------------------------------------------------------------------------
   if (Show_Weekly_Pivots)
      {  	 	
      string wpLineStr,wpStr,wp,ws1Str;
      string wS1LineStr,ws1,wr1Str,wR1LineStr,wr1;
   	string ws2Str,wS2LineStr,ws2,wr2Str,wR2LineStr,wr2; 
   	string ws3Str,wS3LineStr,ws3,wr3Str,wR3LineStr,wr3;
   	string ws4Str,wS4LineStr,ws4,wr4Str,wR4LineStr,wr4;
   	string ws5Str,wS5LineStr,ws5,wr5Str,wR5LineStr,wr5;
   	string wmrLineStr;
	
      if (Weekly_Use_Day_Formula)
         { 
         wpLineStr  = "   WPV";
         wS1LineStr = "   WS1";
         wR1LineStr = "   WR1";
         wS2LineStr = "   WS2";
         wR2LineStr = "   WR2";
         wS3LineStr = "   WS3";
         wR3LineStr = "   WR3";
         wmrLineStr = "Wm";            
         }        
      else  
         {
         wpLineStr  = " WFPV";
         wS1LineStr = " WFS1";
         wR1LineStr = " WFR1";
         wS2LineStr = " WFS2";
         wR2LineStr = " WFR2";
         wS3LineStr = " WFS3";
         wR3LineStr = " WFR3";
         wS4LineStr = " WFS4";
         wR4LineStr = " WFR4";
         wS5LineStr = " WFS5";
         wR5LineStr = " WFR5";
         wmrLineStr = "Wm";
         }
                   
      CalcPeriod = 10080; 
      shift	= iBarShift(NULL,CalcPeriod,Time[0])+ 1;//default=one period ago	 
   
   	ClosePrice  = NormalizeDouble(iClose(NULL,CalcPeriod,shift),4);
      HiPrice     = NormalizeDouble (iHigh(NULL,CalcPeriod,shift),4); 
      LoPrice     = NormalizeDouble (iLow(NULL,CalcPeriod,shift),4);
      Range       = HiPrice -  LoPrice;
      Pivot       = NormalizeDouble((HiPrice+LoPrice+ClosePrice)/3,4);
      
      if (Weekly_Use_Day_Formula)
         {
         R1 = (2*Pivot)-LoPrice;
         S1 = (2*Pivot)-HiPrice;
         R2 = Pivot+(R1-S1);
         S2 = Pivot-(R1-S1); 
         R3 = ( 2.0 * Pivot) + ( HiPrice - ( 2.0 * LoPrice ) );
         S3 = ( 2.0 * Pivot) - ( ( 2.0 * HiPrice ) - LoPrice );         
         }
      else
         {   
         R1 = Pivot + (Range  * 0.382);
         S1 = Pivot - (Range  * 0.382); 
         R2 = Pivot + (Range  * 0.618);
         S2 = Pivot - (Range  * 0.618);
         R3 = Pivot +  Range ;  
         S3 = Pivot -  Range ;
         R4 = Pivot + (Range  * 1.618);
         S4 = Pivot - (Range  * 1.618);
         R5 = Pivot + (Range  * 2.618);
         S5 = Pivot - (Range  * 2.618);
         }

      
      drawLine("wR3", R3, Resistance_Pivots_Color,startofday,startofday2); 
      drawLabel( wR3LineStr,R3,PivotLabels_Color);
      drawLine("wR2", R2, Resistance_Pivots_Color,startofday,startofday2);
      drawLabel(wR2LineStr,R2,PivotLabels_Color);
      drawLine("wR1", R1, Resistance_Pivots_Color,startofday,startofday2);
      drawLabel(wR1LineStr,R1,PivotLabels_Color);
      drawLine("wPIVOT", Pivot, Central_Pivot_Color,startofday,startofday2);
      drawLabel(wpLineStr, Pivot,PivotLabels_Color);
      drawLine("wS1", S1, Support_Pivots_Color,startofday,startofday2);
      drawLabel(wS1LineStr,S1,PivotLabels_Color);
      drawLine("wS2", S2, Support_Pivots_Color,startofday,startofday2);
      drawLabel(wS2LineStr,S2,PivotLabels_Color);
      drawLine("wS3", S3, Support_Pivots_Color,startofday,startofday2);
      drawLabel(wS3LineStr ,S3,PivotLabels_Color);
      
      if (Weekly_Use_Day_Formula==false){
      drawLine("wR5", R5, Resistance_Pivots_Color,startofday,startofday2); 
      drawLabel( wR5LineStr,R5,PivotLabels_Color);
      drawLine("wR4", R4, Resistance_Pivots_Color,startofday,startofday2);
      drawLabel(wR4LineStr,R4,PivotLabels_Color);      
      drawLine("wS4", S4, Support_Pivots_Color,startofday,startofday2);
      drawLabel(wS4LineStr,S4,PivotLabels_Color);
      drawLine("wS5", S5, Support_Pivots_Color,startofday,startofday2);
      drawLabel(wS5LineStr ,S5,PivotLabels_Color);}

      if(Show_Weekly_MidPivots){   
      drawLine("wMR3", (R2+R3)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(wmrLineStr+"R3",(R2+R3)/2,PivotLabels_Color);
      drawLine("wMR2", (R1+R2)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(wmrLineStr+"R2",(R1+R2)/2,PivotLabels_Color); 
      drawLine("wMR1", (Pivot+R1)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(wmrLineStr+"R1",(Pivot+R1)/2,PivotLabels_Color);
      drawLine("wMS1", (Pivot+S1)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(wmrLineStr+"S1",(Pivot+S1)/2,PivotLabels_Color);
      drawLine("wMS2", (S1+S2)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(wmrLineStr+"S2",(S1+S2)/2,PivotLabels_Color);
      drawLine("wMS3", (S2+S3)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(wmrLineStr+"S3",(S2+S3)/2,PivotLabels_Color);}
         
      if (Weekly_Use_Day_Formula==false){   
      drawLine("wMR5", (R4+R5)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(wmrLineStr+"R5",(R4+R5)/2,PivotLabels_Color);
      drawLine("wMR4", (R3+R4)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(wmrLineStr+"R4",(R3+R4)/2,PivotLabels_Color);        
      drawLine("wMS4", (S3+S4)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(wmrLineStr+"S4",(S3+S4)/2,PivotLabels_Color);
      drawLine("wMS5", (S4+S5)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(wmrLineStr+"S5",(S4+S5)/2,PivotLabels_Color);}
      }

   //Do Monthly Pivots------------------------------------------------------------------------- 
   if (Show_Monthly_Pivots)
      {    
   	string mpLineStr,mpStr,mp;
   	string ms1Str,mS1LineStr,ms1,mr1Str,mR1LineStr,mr1;
   	string ms2Str,mS2LineStr,ms2,mr2Str,mR2LineStr,mr2; 
   	string ms3Str,mS3LineStr,ms3,mr3Str,mR3LineStr,mr3;
   	string ms4Str,mS4LineStr,ms4,mr4Str,mR4LineStr,mr4;
   	string ms5Str,mS5LineStr,ms5,mr5Str,mR5LineStr,mr5;
   	string mmrLineStr;
  
      if (Monthly_Use_Day_Formula)
         {
         mpLineStr  = "    MPV";
         mS1LineStr = "    MS1";
         mR1LineStr = "    MR1";
         mS2LineStr = "    MS2";
         mR2LineStr = "    MR2";
         mS3LineStr = "    MS3";
         mR3LineStr = "    MR3";
         mmrLineStr = " Mm";           
         }        
      else   
         {
         mpLineStr  = "  MFPV";
         mS1LineStr = "  MFS1";
         mR1LineStr = "  MFR1";
         mS2LineStr = "  MFS2";
         mR2LineStr = "  MFR2";
         mS3LineStr = "  MFS3";
         mR3LineStr = "  MFR3";
         mS4LineStr = "  MFS4";
         mR4LineStr = "  MFR4";
         mS5LineStr = "  MFS5";
         mR5LineStr = "  MFR5";
         mmrLineStr = " Mm";
         }
         
      CalcPeriod = 43200;
      shift	= iBarShift(NULL,CalcPeriod,Time[0])+ 1;//default=one period ago	 

    	ClosePrice  = NormalizeDouble(iClose(NULL,CalcPeriod,shift),4);
      HiPrice     = NormalizeDouble (iHigh(NULL,CalcPeriod,shift),4); 
      LoPrice     = NormalizeDouble (iLow(NULL,CalcPeriod,shift),4);
      Range       = HiPrice -  LoPrice;
      Pivot       = NormalizeDouble((HiPrice+LoPrice+ClosePrice)/3,4);
      
      if (Monthly_Use_Day_Formula)
         {
         R1 = (2*Pivot)-LoPrice;
         S1 = (2*Pivot)-HiPrice;
         R2 = Pivot+(R1-S1);
         S2 = Pivot-(R1-S1); 
         R3 = ( 2.0 * Pivot) + ( HiPrice - ( 2.0 * LoPrice ) );
         S3 = ( 2.0 * Pivot) - ( ( 2.0 * HiPrice ) - LoPrice );
         }
      else
         {   
         R1 = Pivot + (Range  * 0.382);
         S1 = Pivot - (Range  * 0.382); 
         R2 = Pivot + (Range  * 0.618);
         S2 = Pivot - (Range  * 0.618);
         R3 = Pivot +  Range ;  
         S3 = Pivot -  Range ;
         R4 = Pivot + (Range  * 1.618);
         S4 = Pivot - (Range  * 1.618);
         R5 = Pivot + (Range  * 2.618);
         S5 = Pivot - (Range  * 2.618);        
         } 
     
      drawLine("mR3", R3, Resistance_Pivots_Color,startofday,startofday2); 
      drawLabel(mR3LineStr,R3,PivotLabels_Color);
      drawLine("mR2", R2, Resistance_Pivots_Color,startofday,startofday2);
      drawLabel(mR2LineStr,R2,PivotLabels_Color);
      drawLine("mR1", R1, Resistance_Pivots_Color,startofday,startofday2);
      drawLabel(mR1LineStr,R1,PivotLabels_Color);
      drawLine("mPIVOT", Pivot, Central_Pivot_Color,startofday,startofday2);
      drawLabel(mpLineStr, Pivot,PivotLabels_Color);
      drawLine("mS1", S1, Support_Pivots_Color,startofday,startofday2);
      drawLabel(mS1LineStr,S1,PivotLabels_Color);
      drawLine("mS2", S2, Support_Pivots_Color,startofday,startofday2);
      drawLabel(mS2LineStr,S2,PivotLabels_Color);
      drawLine("mS3", S3, Support_Pivots_Color,startofday,startofday2);
      drawLabel(mS3LineStr ,S3,PivotLabels_Color);
      
      if (Monthly_Use_Day_Formula==false){
      drawLine("mR5", R5, Resistance_Pivots_Color,startofday,startofday2); 
      drawLabel(mR5LineStr,R5,PivotLabels_Color);
      drawLine("mR4", R4, Resistance_Pivots_Color,startofday,startofday2);
      drawLabel(mR4LineStr,R4,PivotLabels_Color);
      drawLine("mS4", S4, Support_Pivots_Color,startofday,startofday2);
      drawLabel(mS4LineStr,S4,PivotLabels_Color);
      drawLine("mS5", S5, Support_Pivots_Color,startofday,startofday2);
      drawLabel(mS5LineStr ,S5,PivotLabels_Color);}   
         
      if(Show_Monthly_MidPivots){      
      drawLine("mMR3", (R2+R3)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(mmrLineStr+"R3",(R2+R3)/2,PivotLabels_Color);
      drawLine("mMR2", (R1+R2)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(mmrLineStr+"R2",(R1+R2)/2,PivotLabels_Color); 
      drawLine("mMR1", (Pivot+R1)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(mmrLineStr+"R1",(Pivot+R1)/2,PivotLabels_Color);
      drawLine("mMS1", (Pivot+S1)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(mmrLineStr+"S1",(Pivot+S1)/2,PivotLabels_Color);
      drawLine("mMS2", (S1+S2)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(mmrLineStr+"S2",(S1+S2)/2,PivotLabels_Color);
      drawLine("mMS3", (S2+S3)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(mmrLineStr+"S3",(S2+S3)/2,PivotLabels_Color);}
      
      if (Monthly_Use_Day_Formula==false){
      drawLine("mMR5", (R4+R5)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(mmrLineStr+"R5",(R4+R5)/2,PivotLabels_Color);
      drawLine("mMR4", (R3+R4)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(mmrLineStr+"R4",(R3+R4)/2,PivotLabels_Color);
      drawLine("mMS4", (S3+S4)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(mmrLineStr+"S4",(S3+S4)/2,PivotLabels_Color);
      drawLine("mMS5", (S4+S5)/2, MidPivots_Color,startofday,startofday2); 
      drawLabel(mmrLineStr+"S5",(S4+S5)/2,PivotLabels_Color);}        
      }         
   return(0);
   } 

//+-------------------------------------------------------------------------------------------+
//| drawLabel sub-routine to name and draw labels for pivot lines                             |                                                        
//+-------------------------------------------------------------------------------------------+
void drawLabel(string text, double level, color Color)
    {    
    //Determine start time for labels
    if (Shift_PivotLabels_PerCent_Left <= 0)   {Shift_PivotLabels_PerCent_Left =0;}
    if (Shift_PivotLabels_PerCent_Left >= 100) {Shift_PivotLabels_PerCent_Left =100;}
    int A = WindowFirstVisibleBar();
    int L = A*(Shift_PivotLabels_PerCent_Left)/100;
    
    //Assign label name to the pivot line labels
    string plabel = "[PivotsMW] " + text + " Label";
                                     
    //Define the digits used for price in label
    if (Use_For_Forex) {Price=DoubleToStr(level, fxDigits);}
    else {Price=DoubleToStr(level, Digits);}         

    if (Show_Price_in_PivotLabels && StrToInteger(text)==0) {text = text + "   " + Price;}     
           
    //Set any additional text spacing required in labels 
    if (Shift_PivotLabels_PerCent_Left == 0)
       {
       text = "                                               " + text;//47
       }
    if (Shift_PivotLabels_PerCent_Left == 100)
       {
       if(Show_Price_in_PivotLabels){text="                              "+text;}//30
       if(Show_Price_in_PivotLabels==false){text = "                " + text;}  //16       
       }
       
    if (StartLines_At_Current_Candle){
       L = 0;
       if(Show_Price_in_PivotLabels){text=""+text;}//0
       if(Show_Price_in_PivotLabels==false){text = "  " + text;}//2       
       }
     
    //Draw the labels    
    if(ObjectFind(plabel) != 0){     
       ObjectCreate(plabel, OBJ_TEXT, 0, Time[L], level);       
       ObjectSetText(plabel, text, PivotLabels_Fontsize, PivotLabels_FontStyle, Color);
       ObjectSet(plabel, OBJPROP_BACK, false);
       if(Subordinate_Labels) {ObjectSet(plabel, OBJPROP_BACK, true);}}
    else{ObjectMove(plabel, 0, Time[L], level);}            
    }
//+-------------------------------------------------------------------------------------------+
//| drawLine sub-routine to name and draw pivot lines                                         |                                                        
//+-------------------------------------------------------------------------------------------+
void drawLine(string text, double level, color Color, datetime startofday, datetime startofday2)    
    {
    int a = PriorDaysFS_LineStyle_01234;
    int b = PriorDaysFS_SolidLineThickness;
    int c =1; if (a==0)c=b;        
    int u = CurrentDay_LineStyle_01234;
    int v = CurrentDay_SolidLineThickness;
    int w =1; if (u==0)w=v;    
    int Y,Z= OBJ_TREND, F= true; //F=true=extend line as ray line
    
    string pline1= "[PivotsMW] " + text + " Line historic";//Lines historic
    string pline2= "[PivotsMW] " + text + " Line today";//Lines today zone  
    string pline3= "[PivotsMW] " + text + " Line full screen";//Lines fullscreen Y=1,F=true and HLINE
      
    if(Line_Configuration_Number==1){ 
       Y=1; Z=OBJ_HLINE; 
       if(Show_RightMargin_Prices == false || Endlines_At_Current_Candle) {Z = OBJ_TREND;}}
       
    if (StartLines_At_Current_Candle) {Y= 2; Z= OBJ_TREND; F= true;}
       
    if (Endlines_At_Current_Candle) {Z= OBJ_TREND; F= false;}           
       
    if(Y!=1){
       if(ObjectFind(pline1) != 0){        
       ObjectCreate(pline1, Z, 0, startofday, level, WindowFirstVisibleBar(), level);                            
       ObjectSet(pline1, OBJPROP_STYLE, a);              
       ObjectSet(pline1, OBJPROP_WIDTH, c); 
       ObjectSet(pline1, OBJPROP_COLOR, Color);
       ObjectSet(pline1, OBJPROP_BACK, true);}}      
    if(Y!=1){
       if(ObjectFind(pline2) != 0){        
       ObjectCreate(pline2, Z, 0, startofday2, level, Time[0], level);                   
       ObjectSet(pline2, OBJPROP_STYLE, u);              
       ObjectSet(pline2, OBJPROP_WIDTH, v); 
       ObjectSet(pline2, OBJPROP_COLOR, Color);
       ObjectSet(pline2, OBJPROP_BACK, true); 
       ObjectSet(pline2, OBJPROP_RAY, F);}}                 
    if(Y==1){
       if(ObjectFind(pline3) != 0){        
       ObjectCreate(pline3, Z, 0, WindowFirstVisibleBar(), level, Time[0], level);                            
       ObjectSet(pline3, OBJPROP_STYLE, a);              
       ObjectSet(pline3, OBJPROP_WIDTH, c); 
       ObjectSet(pline3, OBJPROP_COLOR, Color);
       ObjectSet(pline3, OBJPROP_BACK, true); 
       ObjectSet(pline3, OBJPROP_RAY, F);}}
    if(Y==2){
       ObjectDelete(pline1);
       ObjectDelete(pline3);
       if(ObjectFind(pline2) != 0){        
       ObjectCreate(pline2, Z, 0, NULL, level, Time[1], level);                   
       ObjectSet(pline2, OBJPROP_STYLE, u);              
       ObjectSet(pline2, OBJPROP_WIDTH, v); 
       ObjectSet(pline2, OBJPROP_COLOR, Color);
       ObjectSet(pline2, OBJPROP_BACK, true); 
       ObjectSet(pline2, OBJPROP_RAY, F);}}     
       
       
    else{      
       if(Y!=1){     
       ObjectMove  (pline1, 1, WindowFirstVisibleBar(),level);
       ObjectMove  (pline1, 0, startofday, level);}  
       if(Y!=1){
       ObjectMove  (pline2, 1, Time[0],level);                               
       ObjectMove  (pline2, 0, startofday2, level);}     
       if(Y==1){ 
       ObjectMove  (pline3, 0, WindowFirstVisibleBar(),level);
       ObjectMove  (pline3, 1, Time[0], level);}} 
       if(Y==2){
       ObjectMove  (pline2, 1, NULL,level);                               
       ObjectMove  (pline2, 0, Time[1], level);}          
    }
//+-------------------------------------------------------------------------------------------+
//| End of Program                                                                            |                                                        
//+-------------------------------------------------------------------------------------------+

